/* Sophos Anti-Virus for OS/2
   Adjust 1.00   July 2001
   Copyright (c) 2001 Sophos Plc, www.sophos.com
   Adjust CONFIG.SYS if necessary for deferred files processing. */

CALL RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
CALL SysLoadFuncs

ERROR_CODE = X2D("8000")
globals = "ERROR_CODE"

PARSE ARG ConfigLocation
IF ConfigLocation = "" THEN DO
    SAY "Usage: ADJUST ConfigLocation"
    EXIT ERROR_CODE
END
ConfigFile = ConfigLocation
IF RIGHT(ConfigFile, 1) = ":" THEN
    ConfigFile = ConfigFile || "\CONFIG.SYS"

HpfsLineText = AdjustmentNeeded(ConfigFile)
IF HpfsLineText \= "" THEN DO
    ConfigDir = FILESPEC("D", ConfigFile) || FILESPEC("P", ConfigFile)
    BackupFile = ConfigDir || "CONFIG.SAV"
    TempFile = ConfigDir || SysTempFileName("SAV?????.TMP")
    CALL AdjustConfig ConfigFile, TempFile, BackupFile, HpfsLineText
END

EXIT 0


AdjustmentNeeded: PROCEDURE EXPOSE (globals)
    PARSE ARG ConfigFile
    DeviceLineSeen = 0
    HpfsLineText = ""
    DO WHILE LINES(ConfigFile) > 0
        inline = LINEIN(ConfigFile)
        PARSE UPPER VALUE inline WITH stmt "=" val
        IF stmt = "IFS" & (POS("HPFS.IFS", val) > 0 | POS("HPFS386.IFS", val) > 0) THEN
        DO
            IF DeviceLineSeen THEN
                HpfsLineText = inline
            LEAVE
        END
        ELSE IF stmt = "DEVICE" THEN
            DeviceLineSeen = 1
    END
    CALL STREAM ConfigFile, "C", "CLOSE"
    RETURN HpfsLineText


AdjustConfig: PROCEDURE EXPOSE (globals)
    PARSE ARG ConfigFile, TempFile, BackupFile, HpfsLineText
    e = SysFileDelete(TempFile)
    IF e > 3 THEN DO
        SAY "Error" e "deleting" TempFile
        EXIT ERROR_CODE
    END
    HpfsLineInserted = 0
    DO WHILE LINES(ConfigFile) > 0
        inline = LINEIN(ConfigFile)
        PARSE UPPER VALUE inline WITH stmt "=" val
        IF stmt = "DEVICE" & \ HpfsLineInserted THEN DO
            CALL LINEOUT TempFile, HpfsLineText
            CALL LINEOUT TempFile, inline
            HpfsLineInserted = 1
        END
        ELSE IF inline \= HpfsLineText THEN
            CALL LINEOUT TempFile, inline
    END
    CALL STREAM ConfigFile, "C", "CLOSE"
    CALL STREAM TempFile, "C", "CLOSE"
    CALL CheckCopyFile ConfigFile, BackupFile
    CALL CheckCopyFile TempFile, ConfigFile
    CALL SysFileDelete TempFile
    RETURN 0


CheckCopyFile: PROCEDURE EXPOSE (globals)
    PARSE ARG src, dest
    "@COPY" src dest ">NUL 2>NUL"
    IF RC > 0 THEN DO
        SAY "Error" RC "copying" src "to" dest
        EXIT ERROR_CODE
    END
    RETURN
