/* Sophos Anti-Virus for OS/2
   Intercheck Restart 1.00   June 2001
   Copyright (c) 2001 Sophos Plc, www.sophos.com
   Stop and restart Intercheck to use new IDE files. */

"@ECHO OFF"

CALL RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
CALL SysLoadFuncs

PARSE SOURCE . . CmdPath
CmdDir = FILESPEC("D", CmdPath) || FILESPEC("P", CmdPath)

/* Check that the required Intercheck elements are installed */
Stopper = "STOPPER.EXE"
Daemon = "ICHKDAEM.EXE"

StopperPath = CmdDir || Stopper
StopperOptions = "d"
StopperCheckOptions = "i"
DaemonPath = CmdDir || Daemon

CALL CheckExists "Intercheck stopper", Stopper, StopperPath
CALL CheckExists "Intercheck daemon", Daemon, DaemonPath

/* Stop Intercheck */
CALL CheckCommand StopperPath StopperOptions, "stopping Intercheck"

/* Restart daemon */
CALL CheckCommand "DETACH" DaemonPath "2>NUL", "starting Intercheck"

/* Determine whether daemon is running */
CALL CheckCommand StopperPath StopperCheckOptions, "checking Intercheck"
"PSTAT | FIND /I ""ICHKDAEM"" >NUL"
IF RC = 0 THEN
    SAY "Intercheck has been restarted successfully."
ELSE
    SAY "ERROR: Intercheck could not be restarted."

EXIT RC


CheckExists: PROCEDURE
    PARSE ARG descrip, name, path
    IF \ FileExists(path) THEN
        CALL Error "The" descrip "(" || name || ") is not installed.", 1
    RETURN


CheckCommand: PROCEDURE
    PARSE ARG cmnd, process
    cmnd
    IF RC > 0 THEN
        CALL Error "Error" process || "."
    RETURN


Error: PROCEDURE
    PARSE ARG msg
    SAY "ERROR:" msg
    EXIT 1


FileExists: PROCEDURE
    PARSE ARG Filename
    Found = 0
    IF SysFileTree(Filename, Files, "FO") = 0 THEN
        IF Files.0 > 0 THEN
            Found = 1
    RETURN Found

